diff --git a/src/main/java/net/minecraft/core/block/RailBlock.java b/src/main/java/net/minecraft/core/block/RailBlock.java
new file mode 100644
index 000000000..8a5495621
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/RailBlock.java
@@ -0,0 +1,509 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.logic.RailDirection;
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.util.helper.Axis;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.HitResult;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.chunk.ChunkPosition;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class RailBlock extends Block {
+    public final boolean isPowered;
+
+    public static boolean isRailBlockAt(World world, int x, int y, int z) {
+        return world.getBlock(x, y, z) instanceof RailBlock;
+    }
+    public RailDirection getRailDirection(WorldSource world, int x, int y, int z){
+        int meta = world.getBlockMetadata(x, y, z);
+        if (isPowered){
+            meta &= 0b111;
+        }
+        return RailDirection.getFromMeta(meta);
+    }
+
+    protected RailBlock(String key, String namespaceId, int id, boolean isPowered) {
+        super(key, namespaceId, id, Material.decoration);
+        this.isPowered = isPowered;
+        setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
+    }
+
+    public boolean getIsPowered() {
+        return isPowered;
+    }
+
+    @Override
+	public AABB getCollisionBoundingBoxFromPool(WorldSource world, int x, int y, int z)
+    {
+        return null;
+    }
+
+    @Override
+	public boolean isSolidRender()
+    {
+        return false;
+    }
+
+    @Override
+    public HitResult collisionRayTrace(World world, int x, int y, int z, Vec3 start, Vec3 end) {
+        setBlockBoundsBasedOnState(world, x, y, z);
+        return super.collisionRayTrace(world, x, y, z, start, end);
+    }
+
+    @Override
+    public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z) {
+        RailDirection direction = getRailDirection(world, x, y, z);
+        if(direction.isSloped()) {
+            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.725F, 1.0F);
+        } else {
+            setBlockBounds(0.0F, 0.0F, 0.0F, 1.0F, 0.125F, 1.0F);
+        }
+    }
+
+    @Override
+	public boolean isCubeShaped()
+    {
+        return false;
+    }
+
+    @Override
+	public boolean canPlaceBlockAt(World world, int x, int y, int z) {
+        return world.canPlaceOnSurfaceOfBlock(x, y - 1, z);
+    }
+
+    @Override
+	public void onBlockPlacedByWorld(World world, int x, int y, int z) {
+        performRailTurn(world, x, y, z, true);
+        if(this == Blocks.RAIL_POWERED) {
+        	onNeighborBlockChange(world, x, y, z, id);
+        }
+    }
+    @Override
+	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId) {
+        if(world.isClientSide) {
+            return;
+        }
+        int meta = world.getBlockMetadata(x, y, z);
+        boolean isPoweredFlagSet = (meta & 0b1000) != 0;
+        RailDirection railDirection = getRailDirection(world, x, y, z);
+
+        if(!isValidState(world, x, y, z)) {
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null);
+            world.setBlockWithNotify(x, y, z, 0);
+            return;
+        }
+
+        Block block = Block.getBlock(blockId);
+
+        if(isPowered) {
+            boolean gettingPower =
+                    world.isBlockIndirectlyGettingPowered(x, y, z) ||
+                    world.isBlockIndirectlyGettingPowered(x, y + 1, z) ||
+                    isConnectedPoweredRail1(world, x, y, z, true, 0) ||
+                    isConnectedPoweredRail1(world, x, y, z, false, 0);
+
+            boolean changedMeta = false;
+            if(gettingPower && !isPoweredFlagSet) {
+                // Set powered bit
+                world.setBlockMetadataWithNotify(x, y, z, railDirection.meta | 0b1000);
+                changedMeta = true;
+            } else if(!gettingPower && isPoweredFlagSet) {
+                // Remove powered bit
+                world.setBlockMetadataWithNotify(x, y, z, railDirection.meta);
+                changedMeta = true;
+            }
+
+            if(changedMeta) {
+                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                if(railDirection.isSloped()) {
+                    world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                }
+            }
+        } else if(block != null && block.isSignalSource() && Rail.getNAdjacentTracks(new Rail(world, x, y, z)) == 3) {
+            performRailTurn(world, x, y, z, false);
+        }
+    }
+    // Checks that the rail is placed on top of a block and doesn't slope into the air
+
+    private boolean isValidState(World world, int x, int y, int z){
+        if (!world.canPlaceOnSurfaceOfBlock(x, y - 1, z)) return false;
+
+        RailDirection railDirection = getRailDirection(world, x, y, z);
+        if(railDirection == RailDirection.SLOPE_E && !world.canPlaceOnSurfaceOfBlock(x + 1, y, z)) {
+            return false;
+        }
+        if(railDirection == RailDirection.SLOPE_W && !world.canPlaceOnSurfaceOfBlock(x - 1, y, z)) {
+            return false;
+        }
+        if(railDirection == RailDirection.SLOPE_N && !world.canPlaceOnSurfaceOfBlock(x, y, z - 1)) {
+            return false;
+        }
+        return railDirection != RailDirection.SLOPE_S || world.canPlaceOnSurfaceOfBlock(x, y, z + 1);
+    }
+    // Turn logic what a regular rail is powered in an intersection
+
+    private void performRailTurn(World world, int x, int y, int z, boolean forceUpdate) {
+        if (!world.isClientSide) {
+            new Rail(world, x, y, z).railTurn(world.isBlockIndirectlyGettingPowered(x, y, z), forceUpdate);
+        }
+    }
+
+    private boolean isConnectedPoweredRail1(World world, int x, int y, int z, boolean forward, int distance) {
+        // Only check for powered rails for an 8 block span
+        if(distance >= 8) {
+            return false;
+        }
+        RailDirection railDirection = getRailDirection(world, x, y, z);
+        Axis axis = Axis.NONE;
+
+        int nextX = x;
+        int nextY = y;
+        int nextZ = z;
+
+        if (forward){
+            nextX += railDirection.getNextRailX();
+            nextY += railDirection.getNextRailY();
+            nextZ += railDirection.getNextRailZ();
+        } else {
+            nextX += railDirection.getPrevRailX();
+            nextY += railDirection.getPrevRailY();
+            nextZ += railDirection.getPrevRailZ();
+        }
+
+        switch(railDirection) {
+            case STRAIGHT_NS:
+            case SLOPE_N:
+            case SLOPE_S:
+                axis = Axis.Z;
+                break;
+
+            case STRAIGHT_EW:
+            case SLOPE_E:
+            case SLOPE_W:
+                axis = Axis.X;
+                break;
+        }
+
+        if(isConnectedPoweredRail2(world, nextX, nextY, nextZ, forward, distance, axis)) { return true; }
+        return railDirection.isStraight() && isConnectedPoweredRail2(world, nextX, nextY - 1, nextZ, forward, distance, axis);
+    }
+
+    private boolean isConnectedPoweredRail2(World world, int x, int y, int z, boolean forward, int distance, Axis axis) {
+        int blockId = world.getBlockId(x, y, z);
+        if(blockId == Blocks.RAIL_POWERED.id) {
+            int meta = world.getBlockMetadata(x, y, z);
+            boolean isPoweredFlagSet = (meta & 0b1000) != 0;
+            RailDirection direction = getRailDirection(world, x, y, z);
+
+            // Return false for perpendicular powered rails
+            if(axis == Axis.X && (
+                    direction == RailDirection.STRAIGHT_NS ||
+                    direction == RailDirection.SLOPE_N ||
+                    direction == RailDirection.SLOPE_S)) {
+                return false;
+            }
+            if(axis == Axis.Z && (
+                    direction == RailDirection.STRAIGHT_EW ||
+                    direction == RailDirection.SLOPE_E ||
+                    direction == RailDirection.SLOPE_W)) {
+                return false;
+            }
+
+            if(isPoweredFlagSet) {
+                // If rail powered return true
+                if(world.isBlockIndirectlyGettingPowered(x, y, z) || world.isBlockIndirectlyGettingPowered(x, y + 1, z)) {
+                    return true;
+                } else { // else check 1 block further down if powered
+                    return isConnectedPoweredRail1(world, x, y, z, forward, distance + 1);
+                }
+            }
+        }
+        return false;
+    }
+
+    @Override
+    public int getPistonPushReaction()
+    {
+        return 0;
+    }
+    public static class Rail {
+        private final World world;
+        private final int x;
+        private final int y;
+        private final int z;
+        private final boolean isPoweredRail;
+        private final List<ChunkPosition> connectedTracks;
+        public Rail(World world, int x, int y, int z) {
+            connectedTracks = new ArrayList<>();
+            this.world = world;
+            this.x = x;
+            this.y = y;
+            this.z = z;
+            Block block = world.getBlock(x, y, z);
+            int meta = world.getBlockMetadata(x, y, z);
+
+            isPoweredRail = block instanceof RailBlock && ((RailBlock) block).isPowered;
+
+            setConnections(RailDirection.getFromMeta(meta));
+        }
+
+        private void setConnections(RailDirection direction) {
+            connectedTracks.clear();
+            connectedTracks.add(new ChunkPosition(x + direction.getNextRailX(), y + direction.getNextRailY(), z + direction.getNextRailZ()));
+            connectedTracks.add(new ChunkPosition(x + direction.getPrevRailX(), y + direction.getPrevRailY(), z + direction.getPrevRailZ()));
+        }
+
+        private void checkAndRemoveMissingRails() {
+            for(int i = 0; i < connectedTracks.size(); i++) {
+                Rail rail = getMinecartTrackLogic(connectedTracks.get(i));
+                if(rail == null || !rail.isConnectedTo(this)) {
+                    connectedTracks.remove(i--);
+                } else {
+                    connectedTracks.set(i, new ChunkPosition(rail.x, rail.y, rail.z));
+                }
+            }
+
+        }
+
+        private boolean isMinecartTrack(int x, int y, int z) {
+            if(RailBlock.isRailBlockAt(world, x, y, z)) {
+                return true;
+            }
+            if(RailBlock.isRailBlockAt(world, x, y + 1, z)) {
+                return true;
+            }
+            return RailBlock.isRailBlockAt(world, x, y - 1, z);
+        }
+
+        private Rail getMinecartTrackLogic(ChunkPosition chunkposition) {
+            if(RailBlock.isRailBlockAt(world, chunkposition.x, chunkposition.y, chunkposition.z)) {
+                return new Rail(world, chunkposition.x, chunkposition.y, chunkposition.z);
+            }
+            if(RailBlock.isRailBlockAt(world, chunkposition.x, chunkposition.y + 1, chunkposition.z)) {
+                return new Rail(world, chunkposition.x, chunkposition.y + 1, chunkposition.z);
+            }
+            if(RailBlock.isRailBlockAt(world, chunkposition.x, chunkposition.y - 1, chunkposition.z)) {
+                return new Rail(world, chunkposition.x, chunkposition.y - 1, chunkposition.z);
+            } else {
+                return null;
+            }
+        }
+
+        private boolean isConnectedTo(Rail rail) {
+            for (ChunkPosition chunkposition : connectedTracks) {
+                if (chunkposition.x == rail.x && chunkposition.z == rail.z) {
+                    return true;
+                }
+            }
+            return false;
+        }
+
+        private boolean isInTrack(int x, int y, int z) {
+            for (ChunkPosition chunkposition : connectedTracks) {
+                if (chunkposition.x == x && chunkposition.z == z) {
+                    return true;
+                }
+            }
+            return false;
+        }
+
+        private int getAdjacentTracks() {
+            int count = 0;
+            if(isMinecartTrack(x, y, z - 1)) { // North
+                count++;
+            }
+            if(isMinecartTrack(x, y, z + 1)) { // South
+                count++;
+            }
+            if(isMinecartTrack(x - 1, y, z)) { // West
+                count++;
+            }
+            if(isMinecartTrack(x + 1, y, z)) { // East
+                count++;
+            }
+            return count;
+        }
+
+        private boolean handleKeyPress(Rail rail) {
+            if(isConnectedTo(rail)) {
+                return true;
+            }
+            return connectedTracks.size() != 2;
+        }
+        private boolean canTrackTurnTo(int x, int y, int z) {
+            Rail rail = getMinecartTrackLogic(new ChunkPosition(x, y, z));
+            if (rail == null) return false;
+
+            rail.checkAndRemoveMissingRails();
+            return rail.handleKeyPress(this);
+        }
+
+        public void railTurn(boolean isPowered, boolean forceUpdate) {
+            boolean flagNorth = canTrackTurnTo(x, y, z - 1);
+            boolean flagSouth = canTrackTurnTo(x, y, z + 1);
+            boolean flagWest = canTrackTurnTo(x - 1, y, z);
+            boolean flagEast = canTrackTurnTo(x + 1, y, z);
+
+            RailDirection railType = RailDirection.NONE;
+            if((flagNorth || flagSouth) && !flagWest && !flagEast) {
+                railType = RailDirection.STRAIGHT_NS;
+            }
+            if((flagWest || flagEast) && !flagNorth && !flagSouth) {
+                railType = RailDirection.STRAIGHT_EW;
+            }
+            if(!isPoweredRail) {
+                if(flagSouth && flagEast && !flagNorth && !flagWest) {
+                    railType = RailDirection.TURN_ES;
+                }
+                if(flagSouth && flagWest && !flagNorth && !flagEast) {
+                    railType = RailDirection.TURN_WS;
+                }
+                if(flagNorth && flagWest && !flagSouth && !flagEast) {
+                    railType = RailDirection.TURN_WN;
+                }
+                if(flagNorth && flagEast && !flagSouth && !flagWest) {
+                    railType = RailDirection.TURN_EN;
+                }
+            }
+            if(railType == RailDirection.NONE) {
+                if(flagNorth || flagSouth) {
+                    railType = RailDirection.STRAIGHT_NS;
+                }
+                if(flagWest || flagEast) {
+                    railType = RailDirection.STRAIGHT_EW;
+                }
+                if(!isPoweredRail) {
+                    if(isPowered) {
+                        if(flagSouth && flagEast) {
+                            railType = RailDirection.TURN_ES;
+                        }
+                        if(flagWest && flagSouth) {
+                            railType = RailDirection.TURN_WS;
+                        }
+                        if(flagEast && flagNorth) {
+                            railType = RailDirection.TURN_EN;
+                        }
+                        if(flagNorth && flagWest) {
+                            railType = RailDirection.TURN_WN;
+                        }
+                    } else {
+                        if(flagNorth && flagWest) {
+                            railType = RailDirection.TURN_WN;
+                        }
+                        if(flagEast && flagNorth) {
+                            railType = RailDirection.TURN_EN;
+                        }
+                        if(flagWest && flagSouth) {
+                            railType = RailDirection.TURN_WS;
+                        }
+                        if(flagSouth && flagEast) {
+                            railType = RailDirection.TURN_ES;
+                        }
+                    }
+                }
+            }
+            if(railType == RailDirection.STRAIGHT_NS) {
+                if(RailBlock.isRailBlockAt(world, x, y + 1, z - 1)) {
+                    railType = RailDirection.SLOPE_N;
+                }
+                if(RailBlock.isRailBlockAt(world, x, y + 1, z + 1)) {
+                    railType = RailDirection.SLOPE_S;
+                }
+            }
+            if(railType == RailDirection.STRAIGHT_EW) {
+                if(RailBlock.isRailBlockAt(world, x + 1, y + 1, z)) {
+                    railType = RailDirection.SLOPE_E;
+                }
+                if(RailBlock.isRailBlockAt(world, x - 1, y + 1, z)) {
+                    railType = RailDirection.SLOPE_W;
+                }
+            }
+            if (railType == RailDirection.NONE) {
+                railType = RailDirection.STRAIGHT_EW;
+            }
+            setConnections(railType);
+
+            int newMeta = railType.meta;
+            if(isPoweredRail) {
+                newMeta |= world.getBlockMetadata(x, y, z) & 0b1000;
+            }
+
+            if(forceUpdate || world.getBlockMetadata(x, y, z) != newMeta) {
+                world.setBlockMetadataWithNotify(x, y, z, newMeta);
+                // Update the rail states of the connected tracks
+                for (ChunkPosition connectedTrack : connectedTracks) {
+                    Rail rail = getMinecartTrackLogic(connectedTrack);
+                    if (rail == null) {
+                        continue;
+                    }
+                    rail.checkAndRemoveMissingRails();
+                    if (rail.handleKeyPress(this)) {
+                        rail.updateRailState(this);
+                    }
+                }
+            }
+        }
+        private void updateRailState(Rail otherLogic) {
+            connectedTracks.add(new ChunkPosition(otherLogic.x, otherLogic.y, otherLogic.z));
+            boolean flagNorth = isInTrack(x, y, z - 1);
+            boolean flagSouth = isInTrack(x, y, z + 1);
+            boolean flagWest = isInTrack(x - 1, y, z);
+            boolean flagEast = isInTrack(x + 1, y, z);
+            RailDirection railDirection = RailDirection.NONE;
+            if(flagNorth || flagSouth) {
+                railDirection = RailDirection.STRAIGHT_NS;
+            }
+            if(flagWest || flagEast) {
+                railDirection = RailDirection.STRAIGHT_EW;
+            }
+            if(!isPoweredRail) {
+                if(flagSouth && flagEast && !flagNorth && !flagWest) {
+                    railDirection = RailDirection.TURN_ES;
+                }
+                if(flagSouth && flagWest && !flagNorth && !flagEast) {
+                    railDirection = RailDirection.TURN_WS;
+                }
+                if(flagNorth && flagWest && !flagSouth && !flagEast) {
+                    railDirection = RailDirection.TURN_WN;
+                }
+                if(flagNorth && flagEast && !flagSouth && !flagWest) {
+                    railDirection = RailDirection.TURN_EN;
+                }
+            }
+            if(railDirection == RailDirection.STRAIGHT_NS) {
+                if(RailBlock.isRailBlockAt(world, x, y + 1, z - 1)) {
+                    railDirection = RailDirection.SLOPE_N;
+                }
+                if(RailBlock.isRailBlockAt(world, x, y + 1, z + 1)) {
+                    railDirection = RailDirection.SLOPE_S;
+                }
+            }
+            if(railDirection == RailDirection.STRAIGHT_EW) {
+                if(RailBlock.isRailBlockAt(world, x + 1, y + 1, z)) {
+                    railDirection = RailDirection.SLOPE_E;
+                }
+                if(RailBlock.isRailBlockAt(world, x - 1, y + 1, z)) {
+                    railDirection = RailDirection.SLOPE_W;
+                }
+            }
+            if(railDirection == RailDirection.NONE) {
+                railDirection = RailDirection.STRAIGHT_NS;
+            }
+            int newMeta = railDirection.meta;
+            if(isPoweredRail) {
+                newMeta |= world.getBlockMetadata(x, y, z) & 0b1000;
+            }
+            world.setBlockMetadataWithNotify(x, y, z, newMeta);
+        }
+
+        public static int getNAdjacentTracks(Rail rail) {
+            return rail.getAdjacentTracks();
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/core/block/RedstoneBlock.java b/src/main/java/net/minecraft/core/block/RedstoneBlock.java
new file mode 100644
index 000000000..89a15b9f1
--- /dev/null
+++ b/src/main/java/net/minecraft/core/block/RedstoneBlock.java
@@ -0,0 +1,115 @@
+package net.minecraft.core.block;
+
+import net.minecraft.core.block.material.Material;
+import net.minecraft.core.util.helper.Color;
+import net.minecraft.client.util.helper.Colors;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.World;
+
+import java.util.Random;
+
+public class RedstoneBlock extends Block
+{
+	public RedstoneBlock(String key, String namespaceId, int id, Material material)
+    {
+		super(key, namespaceId, id, material);
+	}
+
+	@Override
+    public boolean isSignalSource()
+    {
+        return true;
+    }
+	
+    @Override
+    public boolean getSignal(WorldSource blockAccess, int x, int y, int z, Side side)
+    {
+    	return true;
+    }
+    
+    @Override
+    public boolean getDirectSignal(World world, int x, int y, int z, Side side)
+    {
+        return getSignal(world, x, y, z, side);
+    }
+    
+    @Override
+	public void onBlockPlacedByWorld(World world, int x, int y, int z)
+    {
+        for (Side s : Side.sides){
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id);
+        }
+    }
+
+    @Override
+    public void onBlockRemoved(World world, int x, int y, int z, int data)
+    {
+        for (Side s : Side.sides){
+            world.notifyBlocksOfNeighborChange(x + s.getOffsetX(), y + s.getOffsetY(), z + s.getOffsetZ(), id);
+        }
+    }
+
+    
+    @Override
+	public void animationTick(World world, int x, int y, int z, Random rand)
+    {
+        spawnParticles(world, x, y, z);
+    }
+    
+	private void spawnParticles(World world, int x, int y, int z) {
+		Random random = world.rand;
+
+        final int redstoneBrightness = 10;
+		Color color = Colors.allRedstoneColors[redstoneBrightness];
+		if(color == null) {
+			return;
+		}
+		float red = color.getRed() / 255.0f;
+		float green = color.getGreen() / 255.0f;
+		float blue = color.getBlue() / 255.0f;
+		
+		final double d = 0.0625;
+        for (Side s : Side.sides){
+            double px = (double) x + random.nextFloat();
+            double py = (double) y + random.nextFloat();
+            double pz = (double) z + random.nextFloat();
+            switch (s){
+                case BOTTOM:
+                    if (!world.isBlockOpaqueCube(x, y + 1, z)) {
+                        py = (y + 1) + d;
+                    }
+                    break;
+                case TOP:
+                    if (!world.isBlockOpaqueCube(x, y - 1, z)) {
+                        py = (y + 0) - d;
+                    }
+                    break;
+                case NORTH:
+                    if (!world.isBlockOpaqueCube(x, y, z + 1)) {
+                        pz = (z + 1) + d;
+                    }
+                    break;
+                case SOUTH:
+                    if (!world.isBlockOpaqueCube(x, y, z - 1)) {
+                        pz = (z + 0) - d;
+                    }
+                    break;
+                case WEST:
+                    if (!world.isBlockOpaqueCube(x + 1, y, z)) {
+                        px = (x + 1) + d;
+                    }
+                    break;
+                case EAST:
+                    if (!world.isBlockOpaqueCube(x - 1, y, z)) {
+                        px = (x + 0) - d;
+                    }
+                    break;
+            }
+            if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
+                world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
+            }
+        }
+	}
+
+}
diff --git a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java b/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
similarity index 62%
rename from src/main/java/net/minecraft/core/block/BlockOreRedstone.java
rename to src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
index 3feaebfaa..3f6ad8d70 100644
--- a/src/main/java/net/minecraft/core/block/BlockOreRedstone.java
+++ b/src/main/java/net/minecraft/core/block/RedstoneOreBlock.java
@@ -1,10 +1,10 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.entity.TileEntity;
+import net.minecraft.core.block.entity.BlockEntity;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.EntityPlayer;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
-import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Color;
 import net.minecraft.core.util.helper.Side;
@@ -12,35 +12,44 @@ import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.world.World;
 import net.minecraft.core.block.material.Material;
 
+import java.util.HashMap;
+import java.util.Map;
 import java.util.Random;
+import java.util.function.Supplier;
 
 // Referenced classes of package net.minecraft.src:
 //            Block, Material, World, Item, 
-//            EntityPlayer, Entity
+//            Player, Entity
 
-public class BlockOreRedstone extends Block
+public class RedstoneOreBlock extends Block
 {
-
-    public BlockOreRedstone(String key, int id, boolean illuminated, String normalKey, String illuminatedKey)
+    public static Map<Integer, Integer> variantMap = new HashMap<>();
+    private final boolean illuminated;
+    private final Supplier<Block> normalBlock;
+    private final Supplier<Block> illuminatedBlock;
+    public RedstoneOreBlock(String key, String namespaceId, int id, int parentId, Material material, boolean illuminated, Supplier<Block> normalBlock, Supplier<Block> illuminatedBlock)
     {
-        super(key, id, Material.stone);
+        super(key, namespaceId, id, material);
         if(illuminated)
         {
             setTicking(true);
         }
         this.illuminated = illuminated;
-        this.keyNormal = normalKey;
-        this.keyIlluminated = illuminatedKey;
+        this.normalBlock = normalBlock;
+        this.illuminatedBlock = illuminatedBlock;
+        if (parentId > 0){
+            variantMap.put(parentId, id);
+        }
     }
 
     @Override
-    public int tickRate()
+    public int tickDelay()
     {
         return 30;
     }
 
     @Override
-    public void onBlockLeftClicked(World world, int x, int y, int z, EntityPlayer player, Side side, double xHit, double yHit)
+    public void onBlockLeftClicked(World world, int x, int y, int z, Player player, Side side, double xHit, double yHit)
     {
         lightRedstone(world, x, y, z);
         super.onBlockLeftClicked(world, x, y, z, player, side, xHit, yHit);
@@ -59,7 +68,7 @@ public class BlockOreRedstone extends Block
         spawnParticles(world, i, j, k);
         if (!illuminated)
         {
-        	world.setBlockWithNotify(i, j, k, Block.getBlockByName(keyIlluminated).id);
+        	world.setBlockWithNotify(i, j, k, illuminatedBlock.get().id);
         }
     }
 
@@ -68,28 +77,28 @@ public class BlockOreRedstone extends Block
     {
         if(illuminated)
         {
-            world.setBlockWithNotify(x, y, z, Block.getBlockByName(keyNormal).id);
+            world.setBlockWithNotify(x, y, z, normalBlock.get().id);
         }
     }
 
     @Override
-    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, TileEntity tileEntity)
+    public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int x, int y, int z, int meta, BlockEntity blockEntity)
     {
         switch (dropCause)
         {
             case SILK_TOUCH:
             case PICK_BLOCK:
-                return new ItemStack[] { new ItemStack(Block.getBlockByName(this.keyNormal)) };
+                return new ItemStack[] { new ItemStack(normalBlock.get()) };
             case EXPLOSION:
             case PROPER_TOOL:
-                return new ItemStack[] { new ItemStack(Item.dustRedstone, 4 + world.rand.nextInt(2)) };
+                return new ItemStack[] { new ItemStack(Items.DUST_REDSTONE, 4 + world.rand.nextInt(2)) };
             default:
                 return null;
         }
     }
 
     @Override
-	public void randomDisplayTick(World world, int x, int y, int z, Random rand)
+	public void animationTick(World world, int x, int y, int z, Random rand)
     {
         if(illuminated)
         {
@@ -118,19 +127,15 @@ public class BlockOreRedstone extends Block
 			double pz = (double) z + random.nextFloat();
 			
 			if (i == 0 && !world.isBlockOpaqueCube(x, y + 1, z)) py = (y + 1) + d;
-			if (i == 1 && !world.isBlockOpaqueCube(x, y - 1, z)) py = (y + 0) - d;
+			if (i == 1 && !world.isBlockOpaqueCube(x, y - 1, z)) py = (y) - d;
 			if (i == 2 && !world.isBlockOpaqueCube(x, y, z + 1)) pz = (z + 1) + d;
-			if (i == 3 && !world.isBlockOpaqueCube(x, y, z - 1)) pz = (z + 0) - d;
+			if (i == 3 && !world.isBlockOpaqueCube(x, y, z - 1)) pz = (z) - d;
 			if (i == 4 && !world.isBlockOpaqueCube(x + 1, y, z)) px = (x + 1) + d;
-			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x + 0) - d;
+			if (i == 5 && !world.isBlockOpaqueCube(x - 1, y, z)) px = (x) - d;
 			
 			if (px < x || px > (x + 1) || py < 0.0D || py > (y + 1) || pz < z || pz > (z + 1)) {
 				world.spawnParticle("reddust", px, py, pz, red, green, blue, redstoneBrightness);
 			}
 		}
     }
-
-    private boolean illuminated;
-    private String keyNormal;
-    private String keyIlluminated;
 }
